// This file was automatically generated from records.xml
#ifndef SWINDER_RECORDS_H
#define SWINDER_RECORDS_H

#include "utils.h"

namespace Swinder {

void registerRecordClasses();

class BackupRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BackupRecord(Workbook *book);
    virtual ~BackupRecord();

    BackupRecord( const BackupRecord& record );
    BackupRecord& operator=( const BackupRecord& record );

    bool isBackupEnabled() const;
    void setBackupEnabled( bool backupEnabled );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Backup"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class EOFRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    EOFRecord(Workbook *book);
    virtual ~EOFRecord();

    EOFRecord( const EOFRecord& record );
    EOFRecord& operator=( const EOFRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "EOF"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BlankRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BlankRecord(Workbook *book);
    virtual ~BlankRecord();

    BlankRecord( const BlankRecord& record );
    BlankRecord& operator=( const BlankRecord& record );

    unsigned column() const;
    void setColumn( unsigned column );

    unsigned row() const;
    void setRow( unsigned row );

    unsigned xfIndex() const;
    void setXfIndex( unsigned xfIndex );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Blank"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BoolErrRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BoolErrRecord(Workbook *book);
    virtual ~BoolErrRecord();

    BoolErrRecord( const BoolErrRecord& record );
    BoolErrRecord& operator=( const BoolErrRecord& record );

    unsigned column() const;
    void setColumn( unsigned column );

    bool isError() const;
    void setError( bool error );

    unsigned row() const;
    void setRow( unsigned row );

    unsigned value() const;
    void setValue( unsigned value );

    unsigned xfIndex() const;
    void setXfIndex( unsigned xfIndex );

    Value asValue() const;

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "BoolErr"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class StartBlockRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    StartBlockRecord(Workbook *book);
    virtual ~StartBlockRecord();

    StartBlockRecord( const StartBlockRecord& record );
    StartBlockRecord& operator=( const StartBlockRecord& record );

    unsigned frtHeaderOld() const;
    void setFrtHeaderOld( unsigned frtHeaderOld );

    unsigned iObjectContext() const;
    void setIObjectContext( unsigned iObjectContext );

    unsigned iObjectInstance1() const;
    void setIObjectInstance1( unsigned iObjectInstance1 );

    unsigned iObjectInstance2() const;
    void setIObjectInstance2( unsigned iObjectInstance2 );

    unsigned iObjectKind() const;
    void setIObjectKind( unsigned iObjectKind );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "StartBlock"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class EndBlockRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    EndBlockRecord(Workbook *book);
    virtual ~EndBlockRecord();

    EndBlockRecord( const EndBlockRecord& record );
    EndBlockRecord& operator=( const EndBlockRecord& record );

    unsigned frtHeaderOld() const;
    void setFrtHeaderOld( unsigned frtHeaderOld );

    unsigned iObjectKind() const;
    void setIObjectKind( unsigned iObjectKind );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "EndBlock"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ShapePropsStreamRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ShapePropsStreamRecord(Workbook *book);
    virtual ~ShapePropsStreamRecord();

    ShapePropsStreamRecord( const ShapePropsStreamRecord& record );
    ShapePropsStreamRecord& operator=( const ShapePropsStreamRecord& record );

    unsigned cb() const;
    void setCb( unsigned cb );

    unsigned dwChecksum() const;
    void setDwChecksum( unsigned dwChecksum );

    unsigned grbitFrt() const;
    void setGrbitFrt( unsigned grbitFrt );

    UString rgb() const;
    void setRgb( UString rgb );

    unsigned rt() const;
    void setRt( unsigned rt );

    unsigned unused() const;
    void setUnused( unsigned unused );

    unsigned wObjContext() const;
    void setWObjContext( unsigned wObjContext );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ShapePropsStream"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class TextPropsStreamRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    TextPropsStreamRecord(Workbook *book);
    virtual ~TextPropsStreamRecord();

    TextPropsStreamRecord( const TextPropsStreamRecord& record );
    TextPropsStreamRecord& operator=( const TextPropsStreamRecord& record );

    unsigned cb() const;
    void setCb( unsigned cb );

    unsigned dwChecksum() const;
    void setDwChecksum( unsigned dwChecksum );

    unsigned grbitFrt() const;
    void setGrbitFrt( unsigned grbitFrt );

    UString rgb() const;
    void setRgb( UString rgb );

    unsigned rt() const;
    void setRt( unsigned rt );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "TextPropsStream"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ChartFrtInfoRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ChartFrtInfoRecord(Workbook *book);
    virtual ~ChartFrtInfoRecord();

    ChartFrtInfoRecord( const ChartFrtInfoRecord& record );
    ChartFrtInfoRecord& operator=( const ChartFrtInfoRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ChartFrtInfo"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ChartLayout12ARecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ChartLayout12ARecord(Workbook *book);
    virtual ~ChartLayout12ARecord();

    ChartLayout12ARecord( const ChartLayout12ARecord& record );
    ChartLayout12ARecord& operator=( const ChartLayout12ARecord& record );

    unsigned dwChecksum() const;
    void setDwChecksum( unsigned dwChecksum );

    double dx() const;
    void setDx( double dx );

    double dy() const;
    void setDy( double dy );

    bool isFLayoutTargetInner() const;
    void setFLayoutTargetInner( bool fLayoutTargetInner );

    unsigned grbitFrt() const;
    void setGrbitFrt( unsigned grbitFrt );

    unsigned rt() const;
    void setRt( unsigned rt );

    unsigned wHeightMode() const;
    void setWHeightMode( unsigned wHeightMode );

    unsigned wWidthMode() const;
    void setWWidthMode( unsigned wWidthMode );

    unsigned wXMode() const;
    void setWXMode( unsigned wXMode );

    unsigned wYMode() const;
    void setWYMode( unsigned wYMode );

    double x() const;
    void setX( double x );

    int xBR() const;
    void setXBR( int xBR );

    int xTL() const;
    void setXTL( int xTL );

    double y() const;
    void setY( double y );

    int yBR() const;
    void setYBR( int yBR );

    int yTL() const;
    void setYTL( int yTL );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ChartLayout12A"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class LeftMarginRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    LeftMarginRecord(Workbook *book);
    virtual ~LeftMarginRecord();

    LeftMarginRecord( const LeftMarginRecord& record );
    LeftMarginRecord& operator=( const LeftMarginRecord& record );

    double leftMargin() const;
    void setLeftMargin( double leftMargin );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "LeftMargin"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class RightMarginRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    RightMarginRecord(Workbook *book);
    virtual ~RightMarginRecord();

    RightMarginRecord( const RightMarginRecord& record );
    RightMarginRecord& operator=( const RightMarginRecord& record );

    double rightMargin() const;
    void setRightMargin( double rightMargin );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "RightMargin"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class TopMarginRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    TopMarginRecord(Workbook *book);
    virtual ~TopMarginRecord();

    TopMarginRecord( const TopMarginRecord& record );
    TopMarginRecord& operator=( const TopMarginRecord& record );

    double topMargin() const;
    void setTopMargin( double topMargin );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "TopMargin"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BottomMarginRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BottomMarginRecord(Workbook *book);
    virtual ~BottomMarginRecord();

    BottomMarginRecord( const BottomMarginRecord& record );
    BottomMarginRecord& operator=( const BottomMarginRecord& record );

    double bottomMargin() const;
    void setBottomMargin( double bottomMargin );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "BottomMargin"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BoundSheetRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BoundSheetRecord(Workbook *book);
    virtual ~BoundSheetRecord();

    BoundSheetRecord( const BoundSheetRecord& record );
    BoundSheetRecord& operator=( const BoundSheetRecord& record );

    enum SheetState {
        Visible = 0,
        Hidden = 1,
        StrongHidden = 2
    };

    static UString sheetStateToString(SheetState sheetState);

    enum SheetType {
        Worksheet = 0x00,
        Chart = 0x02,
        VBModule = 0x06
    };

    static UString sheetTypeToString(SheetType sheetType);

    unsigned bofPosition() const;
    void setBofPosition( unsigned bofPosition );

    UString sheetName() const;
    void setSheetName( UString sheetName );

    unsigned sheetNameLength() const;
    void setSheetNameLength( unsigned sheetNameLength );

    SheetState sheetState() const;
    void setSheetState( SheetState sheetState );

    SheetType sheetType() const;
    void setSheetType( SheetType sheetType );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "BoundSheet"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CalcModeRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CalcModeRecord(Workbook *book);
    virtual ~CalcModeRecord();

    CalcModeRecord( const CalcModeRecord& record );
    CalcModeRecord& operator=( const CalcModeRecord& record );

    enum CalcMode {
        Manual = 0,
        Automatic = 1,
        SemiAutomatic = -1
    };

    static UString calcModeToString(CalcMode calcMode);

    CalcMode calcMode() const;
    void setCalcMode( CalcMode calcMode );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CalcMode"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ColInfoRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ColInfoRecord(Workbook *book);
    virtual ~ColInfoRecord();

    ColInfoRecord( const ColInfoRecord& record );
    ColInfoRecord& operator=( const ColInfoRecord& record );

    bool isCollapsed() const;
    void setCollapsed( bool collapsed );

    unsigned firstColumn() const;
    void setFirstColumn( unsigned firstColumn );

    bool isHidden() const;
    void setHidden( bool hidden );

    unsigned lastColumn() const;
    void setLastColumn( unsigned lastColumn );

    unsigned outlineLevel() const;
    void setOutlineLevel( unsigned outlineLevel );

    unsigned width() const;
    void setWidth( unsigned width );

    unsigned xfIndex() const;
    void setXfIndex( unsigned xfIndex );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ColInfo"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DataTableRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DataTableRecord(Workbook *book);
    virtual ~DataTableRecord();

    DataTableRecord( const DataTableRecord& record );
    DataTableRecord& operator=( const DataTableRecord& record );

    enum Direction {
        InputRow,
        InputColumn,
        Input2D
    };

    static UString directionToString(Direction direction);

    bool isAlwaysCalc() const;
    void setAlwaysCalc( bool alwaysCalc );

    unsigned firstColumn() const;
    void setFirstColumn( unsigned firstColumn );

    unsigned firstRow() const;
    void setFirstRow( unsigned firstRow );

    unsigned inputColumn1() const;
    void setInputColumn1( unsigned inputColumn1 );

    unsigned inputColumn2() const;
    void setInputColumn2( unsigned inputColumn2 );

    unsigned inputRow1() const;
    void setInputRow1( unsigned inputRow1 );

    unsigned inputRow2() const;
    void setInputRow2( unsigned inputRow2 );

    unsigned lastColumn() const;
    void setLastColumn( unsigned lastColumn );

    unsigned lastRow() const;
    void setLastRow( unsigned lastRow );

    bool isRowColTable() const;
    void setRowColTable( bool rowColTable );

    bool isRowInput() const;
    void setRowInput( bool rowInput );

    Direction direction() const;

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "DataTable"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DateModeRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DateModeRecord(Workbook *book);
    virtual ~DateModeRecord();

    DateModeRecord( const DateModeRecord& record );
    DateModeRecord& operator=( const DateModeRecord& record );

    bool isBase1904() const;
    void setBase1904( bool base1904 );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "DateMode"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DimensionRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DimensionRecord(Workbook *book);
    virtual ~DimensionRecord();

    DimensionRecord( const DimensionRecord& record );
    DimensionRecord& operator=( const DimensionRecord& record );

    unsigned firstColumn() const;
    void setFirstColumn( unsigned firstColumn );

    unsigned firstRow() const;
    void setFirstRow( unsigned firstRow );

    unsigned lastColumnPlus1() const;
    void setLastColumnPlus1( unsigned lastColumnPlus1 );

    unsigned lastRowPlus1() const;
    void setLastRowPlus1( unsigned lastRowPlus1 );

    unsigned lastRow() const;

    unsigned lastColumn() const;

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Dimension"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ExternSheetRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ExternSheetRecord(Workbook *book);
    virtual ~ExternSheetRecord();

    ExternSheetRecord( const ExternSheetRecord& record );
    ExternSheetRecord& operator=( const ExternSheetRecord& record );

    unsigned bookRef( unsigned index ) const;
    void setBookRef( unsigned index, unsigned bookRef );

    unsigned firstSheetRef( unsigned index ) const;
    void setFirstSheetRef( unsigned index, unsigned firstSheetRef );

    unsigned lastSheetRef( unsigned index ) const;
    void setLastSheetRef( unsigned index, unsigned lastSheetRef );

    unsigned refCount() const;
    void setRefCount( unsigned refCount );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ExternSheet"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class FontRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    FontRecord(Workbook *book);
    virtual ~FontRecord();

    FontRecord( const FontRecord& record );
    FontRecord& operator=( const FontRecord& record );

    enum Escapement {
        Normal = 0,
        Superscript = 1,
        Subscript = 2
    };

    static UString escapementToString(Escapement escapement);

    enum Underline {
        None = 0,
        Single = 1,
        Double = 2,
        SingleAccounting = 0x21,
        DoubleAccounting = 0x22
    };

    static UString underlineToString(Underline underline);

    enum FontFamily {
        Unknown = 0,
        Roman = 1,
        Swiss = 2,
        Modern = 3,
        Script = 4,
        Decorative = 5
    };

    static UString fontFamilyToString(FontFamily fontFamily);

    unsigned characterSet() const;
    void setCharacterSet( unsigned characterSet );

    unsigned colorIndex() const;
    void setColorIndex( unsigned colorIndex );

    bool isCondensed() const;
    void setCondensed( bool condensed );

    Escapement escapement() const;
    void setEscapement( Escapement escapement );

    bool isExtended() const;
    void setExtended( bool extended );

    FontFamily fontFamily() const;
    void setFontFamily( FontFamily fontFamily );

    UString fontName() const;
    void setFontName( UString fontName );

    unsigned fontNameLength() const;
    void setFontNameLength( unsigned fontNameLength );

    unsigned fontWeight() const;
    void setFontWeight( unsigned fontWeight );

    unsigned height() const;
    void setHeight( unsigned height );

    bool isItalic() const;
    void setItalic( bool italic );

    bool isOutline() const;
    void setOutline( bool outline );

    bool isShadow() const;
    void setShadow( bool shadow );

    bool isStrikeout() const;
    void setStrikeout( bool strikeout );

    Underline underline() const;
    void setUnderline( Underline underline );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Font"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class HeaderRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    HeaderRecord(Workbook *book);
    virtual ~HeaderRecord();

    HeaderRecord( const HeaderRecord& record );
    HeaderRecord& operator=( const HeaderRecord& record );

    UString header() const;
    void setHeader( UString header );

    unsigned headerLength() const;
    void setHeaderLength( unsigned headerLength );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Header"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class FooterRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    FooterRecord(Workbook *book);
    virtual ~FooterRecord();

    FooterRecord( const FooterRecord& record );
    FooterRecord& operator=( const FooterRecord& record );

    UString footer() const;
    void setFooter( UString footer );

    unsigned footerLength() const;
    void setFooterLength( unsigned footerLength );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Footer"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class FormatRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    FormatRecord(Workbook *book);
    virtual ~FormatRecord();

    FormatRecord( const FormatRecord& record );
    FormatRecord& operator=( const FormatRecord& record );

    UString formatString() const;
    void setFormatString( UString formatString );

    unsigned formatStringLength() const;
    void setFormatStringLength( unsigned formatStringLength );

    unsigned index() const;
    void setIndex( unsigned index );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Format"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class LabelRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    LabelRecord(Workbook *book);
    virtual ~LabelRecord();

    LabelRecord( const LabelRecord& record );
    LabelRecord& operator=( const LabelRecord& record );

    unsigned column() const;
    void setColumn( unsigned column );

    UString label() const;
    void setLabel( UString label );

    unsigned labelLength() const;
    void setLabelLength( unsigned labelLength );

    unsigned row() const;
    void setRow( unsigned row );

    unsigned xfIndex() const;
    void setXfIndex( unsigned xfIndex );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Label"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class LabelSSTRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    LabelSSTRecord(Workbook *book);
    virtual ~LabelSSTRecord();

    LabelSSTRecord( const LabelSSTRecord& record );
    LabelSSTRecord& operator=( const LabelSSTRecord& record );

    unsigned column() const;
    void setColumn( unsigned column );

    unsigned row() const;
    void setRow( unsigned row );

    unsigned sstIndex() const;
    void setSstIndex( unsigned sstIndex );

    unsigned xfIndex() const;
    void setXfIndex( unsigned xfIndex );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "LabelSST"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class MergedCellsRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    MergedCellsRecord(Workbook *book);
    virtual ~MergedCellsRecord();

    MergedCellsRecord( const MergedCellsRecord& record );
    MergedCellsRecord& operator=( const MergedCellsRecord& record );

    unsigned count() const;
    void setCount( unsigned count );

    unsigned firstColumn( unsigned index ) const;
    void setFirstColumn( unsigned index, unsigned firstColumn );

    unsigned firstRow( unsigned index ) const;
    void setFirstRow( unsigned index, unsigned firstRow );

    unsigned lastColumn( unsigned index ) const;
    void setLastColumn( unsigned index, unsigned lastColumn );

    unsigned lastRow( unsigned index ) const;
    void setLastRow( unsigned index, unsigned lastRow );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "MergedCells"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class MulBlankRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    MulBlankRecord(Workbook *book);
    virtual ~MulBlankRecord();

    MulBlankRecord( const MulBlankRecord& record );
    MulBlankRecord& operator=( const MulBlankRecord& record );

    unsigned firstColumn() const;
    void setFirstColumn( unsigned firstColumn );

    unsigned lastColumn() const;
    void setLastColumn( unsigned lastColumn );

    unsigned row() const;
    void setRow( unsigned row );

    unsigned xfIndex( unsigned index ) const;
    void setXfIndex( unsigned index, unsigned xfIndex );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "MulBlank"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class NumberRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    NumberRecord(Workbook *book);
    virtual ~NumberRecord();

    NumberRecord( const NumberRecord& record );
    NumberRecord& operator=( const NumberRecord& record );

    unsigned column() const;
    void setColumn( unsigned column );

    double number() const;
    void setNumber( double number );

    unsigned row() const;
    void setRow( unsigned row );

    unsigned xfIndex() const;
    void setXfIndex( unsigned xfIndex );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Number"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PaletteRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PaletteRecord(Workbook *book);
    virtual ~PaletteRecord();

    PaletteRecord( const PaletteRecord& record );
    PaletteRecord& operator=( const PaletteRecord& record );

    unsigned blue( unsigned index ) const;
    void setBlue( unsigned index, unsigned blue );

    unsigned count() const;
    void setCount( unsigned count );

    unsigned green( unsigned index ) const;
    void setGreen( unsigned index, unsigned green );

    unsigned red( unsigned index ) const;
    void setRed( unsigned index, unsigned red );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Palette"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class RowRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    RowRecord(Workbook *book);
    virtual ~RowRecord();

    RowRecord( const RowRecord& record );
    RowRecord& operator=( const RowRecord& record );

    bool isCollapsed() const;
    void setCollapsed( bool collapsed );

    unsigned firstColumn() const;
    void setFirstColumn( unsigned firstColumn );

    unsigned height() const;
    void setHeight( unsigned height );

    bool isHidden() const;
    void setHidden( bool hidden );

    unsigned lastColumnPlus1() const;
    void setLastColumnPlus1( unsigned lastColumnPlus1 );

    unsigned outlineLevel() const;
    void setOutlineLevel( unsigned outlineLevel );

    unsigned row() const;
    void setRow( unsigned row );

    unsigned xfIndex() const;
    void setXfIndex( unsigned xfIndex );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Row"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class StringRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    StringRecord(Workbook *book);
    virtual ~StringRecord();

    StringRecord( const StringRecord& record );
    StringRecord& operator=( const StringRecord& record );

    unsigned stringLength() const;
    void setStringLength( unsigned stringLength );

    UString ustring() const;
    void setUstring( UString ustring );

    Value value() const;

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "String"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class NoteRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    NoteRecord(Workbook *book);
    virtual ~NoteRecord();

    NoteRecord( const NoteRecord& record );
    NoteRecord& operator=( const NoteRecord& record );

    unsigned column() const;
    void setColumn( unsigned column );

    unsigned idObj() const;
    void setIdObj( unsigned idObj );

    unsigned opts() const;
    void setOpts( unsigned opts );

    unsigned row() const;
    void setRow( unsigned row );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Note"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ProtectRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ProtectRecord(Workbook *book);
    virtual ~ProtectRecord();

    ProtectRecord( const ProtectRecord& record );
    ProtectRecord& operator=( const ProtectRecord& record );

    bool isLocked() const;
    void setLocked( bool locked );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Protect"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DefaultRowHeightRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DefaultRowHeightRecord(Workbook *book);
    virtual ~DefaultRowHeightRecord();

    DefaultRowHeightRecord( const DefaultRowHeightRecord& record );
    DefaultRowHeightRecord& operator=( const DefaultRowHeightRecord& record );

    int miyRw() const;
    void setMiyRw( int miyRw );

    int miyRwHidden() const;
    void setMiyRwHidden( int miyRwHidden );

    unsigned opts() const;
    void setOpts( unsigned opts );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "DefaultRowHeight"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DefaultColWidthRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DefaultColWidthRecord(Workbook *book);
    virtual ~DefaultColWidthRecord();

    DefaultColWidthRecord( const DefaultColWidthRecord& record );
    DefaultColWidthRecord& operator=( const DefaultColWidthRecord& record );

    unsigned cchdefColWidth() const;
    void setCchdefColWidth( unsigned cchdefColWidth );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "DefaultColWidth"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class HCenterRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    HCenterRecord(Workbook *book);
    virtual ~HCenterRecord();

    HCenterRecord( const HCenterRecord& record );
    HCenterRecord& operator=( const HCenterRecord& record );

    bool isCentered() const;
    void setCentered( bool centered );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "HCenter"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class VCenterRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    VCenterRecord(Workbook *book);
    virtual ~VCenterRecord();

    VCenterRecord( const VCenterRecord& record );
    VCenterRecord& operator=( const VCenterRecord& record );

    bool isCentered() const;
    void setCentered( bool centered );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "VCenter"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SetupRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SetupRecord(Workbook *book);
    virtual ~SetupRecord();

    SetupRecord( const SetupRecord& record );
    SetupRecord& operator=( const SetupRecord& record );

    enum ErrorPrintMode {
        ErrorsAsDisplayed = 0,
        ErrorsAsBlank = 1,
        ErrorsAsDashes = 2,
        ErrorsAsNA = 3
    };

    static UString errorPrintModeToString(ErrorPrintMode errorPrintMode);

    bool isCommentsAsEndNotes() const;
    void setCommentsAsEndNotes( bool commentsAsEndNotes );

    bool isCustumStartPageNumber() const;
    void setCustumStartPageNumber( bool custumStartPageNumber );

    bool isDraftQuality() const;
    void setDraftQuality( bool draftQuality );

    ErrorPrintMode errorPrintMode() const;
    void setErrorPrintMode( ErrorPrintMode errorPrintMode );

    unsigned fitHeightToPageCount() const;
    void setFitHeightToPageCount( unsigned fitHeightToPageCount );

    unsigned fitWidthToPageCount() const;
    void setFitWidthToPageCount( unsigned fitWidthToPageCount );

    double footerMargin() const;
    void setFooterMargin( double footerMargin );

    bool isGreyscale() const;
    void setGreyscale( bool greyscale );

    double headerMargin() const;
    void setHeaderMargin( double headerMargin );

    bool isLeftToRight() const;
    void setLeftToRight( bool leftToRight );

    bool isNoOrientationSet() const;
    void setNoOrientationSet( bool noOrientationSet );

    bool isNoPaperSizeSet() const;
    void setNoPaperSizeSet( bool noPaperSizeSet );

    unsigned numCopies() const;
    void setNumCopies( unsigned numCopies );

    unsigned paperSize() const;
    void setPaperSize( unsigned paperSize );

    bool isPortrait() const;
    void setPortrait( bool portrait );

    bool isPrintNotes() const;
    void setPrintNotes( bool printNotes );

    unsigned printResolution() const;
    void setPrintResolution( unsigned printResolution );

    unsigned scalePercentage() const;
    void setScalePercentage( unsigned scalePercentage );

    int startingPageNumber() const;
    void setStartingPageNumber( int startingPageNumber );

    unsigned verticalPrintResolution() const;
    void setVerticalPrintResolution( unsigned verticalPrintResolution );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Setup"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CrtLineRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CrtLineRecord(Workbook *book);
    virtual ~CrtLineRecord();

    CrtLineRecord( const CrtLineRecord& record );
    CrtLineRecord& operator=( const CrtLineRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CrtLine"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class UnitsRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    UnitsRecord(Workbook *book);
    virtual ~UnitsRecord();

    UnitsRecord( const UnitsRecord& record );
    UnitsRecord& operator=( const UnitsRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Units"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PrintSizeRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PrintSizeRecord(Workbook *book);
    virtual ~PrintSizeRecord();

    PrintSizeRecord( const PrintSizeRecord& record );
    PrintSizeRecord& operator=( const PrintSizeRecord& record );

    enum PrintSize {
        WorkbookDefaults = 0,
        FillPage = 1,
        FillPageProportionally = 2,
        SizeFromChartRecord = 3
    };

    static UString printSizeToString(PrintSize printSize);

    PrintSize printSize() const;
    void setPrintSize( PrintSize printSize );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "PrintSize"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ChartRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ChartRecord(Workbook *book);
    virtual ~ChartRecord();

    ChartRecord( const ChartRecord& record );
    ChartRecord& operator=( const ChartRecord& record );

    double height() const;
    void setHeight( double height );

    double width() const;
    void setWidth( double width );

    double x() const;
    void setX( double x );

    double y() const;
    void setY( double y );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Chart"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SheetExtRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SheetExtRecord(Workbook *book);
    virtual ~SheetExtRecord();

    SheetExtRecord( const SheetExtRecord& record );
    SheetExtRecord& operator=( const SheetExtRecord& record );

    unsigned cb() const;
    void setCb( unsigned cb );

    unsigned color() const;
    void setColor( unsigned color );

    bool isFCondFmtCalc() const;
    void setFCondFmtCalc( bool fCondFmtCalc );

    bool isFNotPublished() const;
    void setFNotPublished( bool fNotPublished );

    unsigned icvPlain() const;
    void setIcvPlain( unsigned icvPlain );

    unsigned icvPlain12() const;
    void setIcvPlain12( unsigned icvPlain12 );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "SheetExt"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BeginRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BeginRecord(Workbook *book);
    virtual ~BeginRecord();

    BeginRecord( const BeginRecord& record );
    BeginRecord& operator=( const BeginRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Begin"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class EndRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    EndRecord(Workbook *book);
    virtual ~EndRecord();

    EndRecord( const EndRecord& record );
    EndRecord& operator=( const EndRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "End"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DataFormatRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DataFormatRecord(Workbook *book);
    virtual ~DataFormatRecord();

    DataFormatRecord( const DataFormatRecord& record );
    DataFormatRecord& operator=( const DataFormatRecord& record );

    unsigned iss() const;
    void setIss( unsigned iss );

    unsigned xi() const;
    void setXi( unsigned xi );

    unsigned yi() const;
    void setYi( unsigned yi );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "DataFormat"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class LineFormatRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    LineFormatRecord(Workbook *book);
    virtual ~LineFormatRecord();

    LineFormatRecord( const LineFormatRecord& record );
    LineFormatRecord& operator=( const LineFormatRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "LineFormat"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class MarkerFormatRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    MarkerFormatRecord(Workbook *book);
    virtual ~MarkerFormatRecord();

    MarkerFormatRecord( const MarkerFormatRecord& record );
    MarkerFormatRecord& operator=( const MarkerFormatRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "MarkerFormat"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AreaFormatRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AreaFormatRecord(Workbook *book);
    virtual ~AreaFormatRecord();

    AreaFormatRecord( const AreaFormatRecord& record );
    AreaFormatRecord& operator=( const AreaFormatRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "AreaFormat"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PieRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PieRecord(Workbook *book);
    virtual ~PieRecord();

    PieRecord( const PieRecord& record );
    PieRecord& operator=( const PieRecord& record );

    unsigned anStart() const;
    void setAnStart( unsigned anStart );

    bool isFHasShadow() const;
    void setFHasShadow( bool fHasShadow );

    bool isFShowLdrLines() const;
    void setFShowLdrLines( bool fShowLdrLines );

    unsigned pcDonut() const;
    void setPcDonut( unsigned pcDonut );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Pie"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PieFormatRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PieFormatRecord(Workbook *book);
    virtual ~PieFormatRecord();

    PieFormatRecord( const PieFormatRecord& record );
    PieFormatRecord& operator=( const PieFormatRecord& record );

    int pcExplode() const;
    void setPcExplode( int pcExplode );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "PieFormat"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AttachedLabelRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AttachedLabelRecord(Workbook *book);
    virtual ~AttachedLabelRecord();

    AttachedLabelRecord( const AttachedLabelRecord& record );
    AttachedLabelRecord& operator=( const AttachedLabelRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "AttachedLabel"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ChartFormatRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ChartFormatRecord(Workbook *book);
    virtual ~ChartFormatRecord();

    ChartFormatRecord( const ChartFormatRecord& record );
    ChartFormatRecord& operator=( const ChartFormatRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ChartFormat"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class LegendRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    LegendRecord(Workbook *book);
    virtual ~LegendRecord();

    LegendRecord( const LegendRecord& record );
    LegendRecord& operator=( const LegendRecord& record );

    unsigned dx() const;
    void setDx( unsigned dx );

    unsigned dy() const;
    void setDy( unsigned dy );

    bool isFAutoPosX() const;
    void setFAutoPosX( bool fAutoPosX );

    bool isFAutoPosY() const;
    void setFAutoPosY( bool fAutoPosY );

    bool isFAutoPosition() const;
    void setFAutoPosition( bool fAutoPosition );

    bool isFVert() const;
    void setFVert( bool fVert );

    bool isFWasDataTable() const;
    void setFWasDataTable( bool fWasDataTable );

    unsigned unused() const;
    void setUnused( unsigned unused );

    unsigned wSpace() const;
    void setWSpace( unsigned wSpace );

    unsigned x() const;
    void setX( unsigned x );

    unsigned y() const;
    void setY( unsigned y );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Legend"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SeriesListRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SeriesListRecord(Workbook *book);
    virtual ~SeriesListRecord();

    SeriesListRecord( const SeriesListRecord& record );
    SeriesListRecord& operator=( const SeriesListRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "SeriesList"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BarRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BarRecord(Workbook *book);
    virtual ~BarRecord();

    BarRecord( const BarRecord& record );
    BarRecord& operator=( const BarRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Bar"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class LineRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    LineRecord(Workbook *book);
    virtual ~LineRecord();

    LineRecord( const LineRecord& record );
    LineRecord& operator=( const LineRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Line"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AreaRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AreaRecord(Workbook *book);
    virtual ~AreaRecord();

    AreaRecord( const AreaRecord& record );
    AreaRecord& operator=( const AreaRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Area"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ScatterRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ScatterRecord(Workbook *book);
    virtual ~ScatterRecord();

    ScatterRecord( const ScatterRecord& record );
    ScatterRecord& operator=( const ScatterRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Scatter"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AxisRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AxisRecord(Workbook *book);
    virtual ~AxisRecord();

    AxisRecord( const AxisRecord& record );
    AxisRecord& operator=( const AxisRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Axis"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class TickRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    TickRecord(Workbook *book);
    virtual ~TickRecord();

    TickRecord( const TickRecord& record );
    TickRecord& operator=( const TickRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Tick"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ValueRangeRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ValueRangeRecord(Workbook *book);
    virtual ~ValueRangeRecord();

    ValueRangeRecord( const ValueRangeRecord& record );
    ValueRangeRecord& operator=( const ValueRangeRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ValueRange"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CatSerRangeRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CatSerRangeRecord(Workbook *book);
    virtual ~CatSerRangeRecord();

    CatSerRangeRecord( const CatSerRangeRecord& record );
    CatSerRangeRecord& operator=( const CatSerRangeRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CatSerRange"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AxisLineRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AxisLineRecord(Workbook *book);
    virtual ~AxisLineRecord();

    AxisLineRecord( const AxisLineRecord& record );
    AxisLineRecord& operator=( const AxisLineRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "AxisLine"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CrtLinkRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CrtLinkRecord(Workbook *book);
    virtual ~CrtLinkRecord();

    CrtLinkRecord( const CrtLinkRecord& record );
    CrtLinkRecord& operator=( const CrtLinkRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CrtLink"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DefaultTextRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DefaultTextRecord(Workbook *book);
    virtual ~DefaultTextRecord();

    DefaultTextRecord( const DefaultTextRecord& record );
    DefaultTextRecord& operator=( const DefaultTextRecord& record );

    enum Identifier {
        ShowPercent0_or_ShowValue0 = 0x0000,
        ShowPercent1_or_ShowValue1 = 0x0001,
        Scalable0 = 0x0002,
        Scalable1 = 0x0003
    };

    static UString identifierToString(Identifier identifier);

    Identifier identifier() const;
    void setIdentifier( Identifier identifier );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "DefaultText"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class TextRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    TextRecord(Workbook *book);
    virtual ~TextRecord();

    TextRecord( const TextRecord& record );
    TextRecord& operator=( const TextRecord& record );

    unsigned at() const;
    void setAt( unsigned at );

    unsigned dx() const;
    void setDx( unsigned dx );

    unsigned dy() const;
    void setDy( unsigned dy );

    bool isFAutoColor() const;
    void setFAutoColor( bool fAutoColor );

    bool isFAutoMode() const;
    void setFAutoMode( bool fAutoMode );

    bool isFAutoText() const;
    void setFAutoText( bool fAutoText );

    bool isFDeleted() const;
    void setFDeleted( bool fDeleted );

    bool isFGenerated() const;
    void setFGenerated( bool fGenerated );

    bool isFShowBubbleSizes() const;
    void setFShowBubbleSizes( bool fShowBubbleSizes );

    bool isFShowKey() const;
    void setFShowKey( bool fShowKey );

    bool isFShowLabel() const;
    void setFShowLabel( bool fShowLabel );

    bool isFShowLabelAndPerc() const;
    void setFShowLabelAndPerc( bool fShowLabelAndPerc );

    bool isFShowPercent() const;
    void setFShowPercent( bool fShowPercent );

    bool isFShowValue() const;
    void setFShowValue( bool fShowValue );

    unsigned icvText() const;
    void setIcvText( unsigned icvText );

    unsigned rgbText() const;
    void setRgbText( unsigned rgbText );

    unsigned unused1() const;
    void setUnused1( unsigned unused1 );

    unsigned unused2() const;
    void setUnused2( unsigned unused2 );

    unsigned vat() const;
    void setVat( unsigned vat );

    unsigned wBkgMode() const;
    void setWBkgMode( unsigned wBkgMode );

    unsigned x() const;
    void setX( unsigned x );

    unsigned y() const;
    void setY( unsigned y );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Text"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class FontXRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    FontXRecord(Workbook *book);
    virtual ~FontXRecord();

    FontXRecord( const FontXRecord& record );
    FontXRecord& operator=( const FontXRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "FontX"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ObjectLinkRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ObjectLinkRecord(Workbook *book);
    virtual ~ObjectLinkRecord();

    ObjectLinkRecord( const ObjectLinkRecord& record );
    ObjectLinkRecord& operator=( const ObjectLinkRecord& record );

    enum WLinkObj {
        EntireChart = 0x0001,
        ValueOrVerticalAxis = 0x0002,
        CategoryOrHorizontalAxis = 0x0003,
        SeriesOrDatapoints = 0x0004,
        SeriesAxis = 0x0007,
        DisplayUnitsLabelsOfAxis = 0x000c
    };

    static UString wLinkObjToString(WLinkObj wLinkObj);

    WLinkObj wLinkObj() const;
    void setWLinkObj( WLinkObj wLinkObj );

    unsigned wLinkVar1() const;
    void setWLinkVar1( unsigned wLinkVar1 );

    unsigned wLinkVar2() const;
    void setWLinkVar2( unsigned wLinkVar2 );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ObjectLink"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PlotAreaRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PlotAreaRecord(Workbook *book);
    virtual ~PlotAreaRecord();

    PlotAreaRecord( const PlotAreaRecord& record );
    PlotAreaRecord& operator=( const PlotAreaRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "PlotArea"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class MsoDrawingSelectionRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    MsoDrawingSelectionRecord(Workbook *book);
    virtual ~MsoDrawingSelectionRecord();

    MsoDrawingSelectionRecord( const MsoDrawingSelectionRecord& record );
    MsoDrawingSelectionRecord& operator=( const MsoDrawingSelectionRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "MsoDrawingSelection"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class Chart3dRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    Chart3dRecord(Workbook *book);
    virtual ~Chart3dRecord();

    Chart3dRecord( const Chart3dRecord& record );
    Chart3dRecord& operator=( const Chart3dRecord& record );

    int anElev() const;
    void setAnElev( int anElev );

    int anRot() const;
    void setAnRot( int anRot );

    bool isF3DScaling() const;
    void setF3DScaling( bool f3DScaling );

    bool isFCluster() const;
    void setFCluster( bool fCluster );

    bool isFNotPieChart() const;
    void setFNotPieChart( bool fNotPieChart );

    bool isFPerspective() const;
    void setFPerspective( bool fPerspective );

    bool isFWalls2D() const;
    void setFWalls2D( bool fWalls2D );

    int pcDepth() const;
    void setPcDepth( int pcDepth );

    int pcDist() const;
    void setPcDist( int pcDist );

    unsigned pcGap() const;
    void setPcGap( unsigned pcGap );

    unsigned pcHeight() const;
    void setPcHeight( unsigned pcHeight );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Chart3d"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PicFRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PicFRecord(Workbook *book);
    virtual ~PicFRecord();

    PicFRecord( const PicFRecord& record );
    PicFRecord& operator=( const PicFRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "PicF"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DropBarRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DropBarRecord(Workbook *book);
    virtual ~DropBarRecord();

    DropBarRecord( const DropBarRecord& record );
    DropBarRecord& operator=( const DropBarRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "DropBar"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class RadarRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    RadarRecord(Workbook *book);
    virtual ~RadarRecord();

    RadarRecord( const RadarRecord& record );
    RadarRecord& operator=( const RadarRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Radar"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SurfRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SurfRecord(Workbook *book);
    virtual ~SurfRecord();

    SurfRecord( const SurfRecord& record );
    SurfRecord& operator=( const SurfRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Surf"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class RadarAreaRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    RadarAreaRecord(Workbook *book);
    virtual ~RadarAreaRecord();

    RadarAreaRecord( const RadarAreaRecord& record );
    RadarAreaRecord& operator=( const RadarAreaRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "RadarArea"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AxisParentRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AxisParentRecord(Workbook *book);
    virtual ~AxisParentRecord();

    AxisParentRecord( const AxisParentRecord& record );
    AxisParentRecord& operator=( const AxisParentRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "AxisParent"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class LegendExceptionRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    LegendExceptionRecord(Workbook *book);
    virtual ~LegendExceptionRecord();

    LegendExceptionRecord( const LegendExceptionRecord& record );
    LegendExceptionRecord& operator=( const LegendExceptionRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "LegendException"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ShtPropsRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ShtPropsRecord(Workbook *book);
    virtual ~ShtPropsRecord();

    ShtPropsRecord( const ShtPropsRecord& record );
    ShtPropsRecord& operator=( const ShtPropsRecord& record );

    bool isFAlwaysAutoPlotArea() const;
    void setFAlwaysAutoPlotArea( bool fAlwaysAutoPlotArea );

    bool isFManPlotArea() const;
    void setFManPlotArea( bool fManPlotArea );

    bool isFManSerAlloc() const;
    void setFManSerAlloc( bool fManSerAlloc );

    bool isFNotSizeWIth() const;
    void setFNotSizeWIth( bool fNotSizeWIth );

    bool isFPlotVisOnly() const;
    void setFPlotVisOnly( bool fPlotVisOnly );

    unsigned mdBlank() const;
    void setMdBlank( unsigned mdBlank );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ShtProps"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SerToCrtRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SerToCrtRecord(Workbook *book);
    virtual ~SerToCrtRecord();

    SerToCrtRecord( const SerToCrtRecord& record );
    SerToCrtRecord& operator=( const SerToCrtRecord& record );

    unsigned identifier() const;
    void setIdentifier( unsigned identifier );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "SerToCrt"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AxesUsedRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AxesUsedRecord(Workbook *book);
    virtual ~AxesUsedRecord();

    AxesUsedRecord( const AxesUsedRecord& record );
    AxesUsedRecord& operator=( const AxesUsedRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "AxesUsed"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SBaseRefRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SBaseRefRecord(Workbook *book);
    virtual ~SBaseRefRecord();

    SBaseRefRecord( const SBaseRefRecord& record );
    SBaseRefRecord& operator=( const SBaseRefRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "SBaseRef"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SerParentRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SerParentRecord(Workbook *book);
    virtual ~SerParentRecord();

    SerParentRecord( const SerParentRecord& record );
    SerParentRecord& operator=( const SerParentRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "SerParent"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SerAuxTrendRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SerAuxTrendRecord(Workbook *book);
    virtual ~SerAuxTrendRecord();

    SerAuxTrendRecord( const SerAuxTrendRecord& record );
    SerAuxTrendRecord& operator=( const SerAuxTrendRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "SerAuxTrend"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class IFmtRecordRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    IFmtRecordRecord(Workbook *book);
    virtual ~IFmtRecordRecord();

    IFmtRecordRecord( const IFmtRecordRecord& record );
    IFmtRecordRecord& operator=( const IFmtRecordRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "IFmtRecord"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PosRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PosRecord(Workbook *book);
    virtual ~PosRecord();

    PosRecord( const PosRecord& record );
    PosRecord& operator=( const PosRecord& record );

    unsigned mdBotRt() const;
    void setMdBotRt( unsigned mdBotRt );

    unsigned mdTopLt() const;
    void setMdTopLt( unsigned mdTopLt );

    unsigned unused1() const;
    void setUnused1( unsigned unused1 );

    unsigned unused2() const;
    void setUnused2( unsigned unused2 );

    unsigned unused3() const;
    void setUnused3( unsigned unused3 );

    unsigned unused4() const;
    void setUnused4( unsigned unused4 );

    unsigned x1() const;
    void setX1( unsigned x1 );

    unsigned x2() const;
    void setX2( unsigned x2 );

    unsigned y1() const;
    void setY1( unsigned y1 );

    unsigned y2() const;
    void setY2( unsigned y2 );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Pos"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AIRunsRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AIRunsRecord(Workbook *book);
    virtual ~AIRunsRecord();

    AIRunsRecord( const AIRunsRecord& record );
    AIRunsRecord& operator=( const AIRunsRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "AIRuns"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SerAuxErrBarRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SerAuxErrBarRecord(Workbook *book);
    virtual ~SerAuxErrBarRecord();

    SerAuxErrBarRecord( const SerAuxErrBarRecord& record );
    SerAuxErrBarRecord& operator=( const SerAuxErrBarRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "SerAuxErrBar"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ClrtClientRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ClrtClientRecord(Workbook *book);
    virtual ~ClrtClientRecord();

    ClrtClientRecord( const ClrtClientRecord& record );
    ClrtClientRecord& operator=( const ClrtClientRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ClrtClient"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SerFmtRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SerFmtRecord(Workbook *book);
    virtual ~SerFmtRecord();

    SerFmtRecord( const SerFmtRecord& record );
    SerFmtRecord& operator=( const SerFmtRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "SerFmt"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class Chart3DBarShapeRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    Chart3DBarShapeRecord(Workbook *book);
    virtual ~Chart3DBarShapeRecord();

    Chart3DBarShapeRecord( const Chart3DBarShapeRecord& record );
    Chart3DBarShapeRecord& operator=( const Chart3DBarShapeRecord& record );

    unsigned riser() const;
    void setRiser( unsigned riser );

    unsigned taper() const;
    void setTaper( unsigned taper );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Chart3DBarShape"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class FbiRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    FbiRecord(Workbook *book);
    virtual ~FbiRecord();

    FbiRecord( const FbiRecord& record );
    FbiRecord& operator=( const FbiRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Fbi"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BopPopRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BopPopRecord(Workbook *book);
    virtual ~BopPopRecord();

    BopPopRecord( const BopPopRecord& record );
    BopPopRecord& operator=( const BopPopRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "BopPop"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AxcExtRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AxcExtRecord(Workbook *book);
    virtual ~AxcExtRecord();

    AxcExtRecord( const AxcExtRecord& record );
    AxcExtRecord& operator=( const AxcExtRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "AxcExt"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DatRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DatRecord(Workbook *book);
    virtual ~DatRecord();

    DatRecord( const DatRecord& record );
    DatRecord& operator=( const DatRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Dat"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PlotGrowthRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PlotGrowthRecord(Workbook *book);
    virtual ~PlotGrowthRecord();

    PlotGrowthRecord( const PlotGrowthRecord& record );
    PlotGrowthRecord& operator=( const PlotGrowthRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "PlotGrowth"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SIIndexRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SIIndexRecord(Workbook *book);
    virtual ~SIIndexRecord();

    SIIndexRecord( const SIIndexRecord& record );
    SIIndexRecord& operator=( const SIIndexRecord& record );

    unsigned numIndex() const;
    void setNumIndex( unsigned numIndex );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "SIIndex"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class GelFrameRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    GelFrameRecord(Workbook *book);
    virtual ~GelFrameRecord();

    GelFrameRecord( const GelFrameRecord& record );
    GelFrameRecord& operator=( const GelFrameRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "GelFrame"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BobPopCustomRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BobPopCustomRecord(Workbook *book);
    virtual ~BobPopCustomRecord();

    BobPopCustomRecord( const BobPopCustomRecord& record );
    BobPopCustomRecord& operator=( const BobPopCustomRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "BobPopCustom"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class Fbi2Record : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    Fbi2Record(Workbook *book);
    virtual ~Fbi2Record();

    Fbi2Record( const Fbi2Record& record );
    Fbi2Record& operator=( const Fbi2Record& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Fbi2"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ZoomLevelRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ZoomLevelRecord(Workbook *book);
    virtual ~ZoomLevelRecord();

    ZoomLevelRecord( const ZoomLevelRecord& record );
    ZoomLevelRecord& operator=( const ZoomLevelRecord& record );

    int denominator() const;
    void setDenominator( int denominator );

    int numerator() const;
    void setNumerator( int numerator );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ZoomLevel"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class FrameRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    FrameRecord(Workbook *book);
    virtual ~FrameRecord();

    FrameRecord( const FrameRecord& record );
    FrameRecord& operator=( const FrameRecord& record );

    enum FrameType {
        SimpleFrame = 0,
        ShadowedFrame = 4
    };

    static UString frameTypeToString(FrameType frameType);

    bool isAutoPosition() const;
    void setAutoPosition( bool autoPosition );

    bool isAutoSize() const;
    void setAutoSize( bool autoSize );

    FrameType frameType() const;
    void setFrameType( FrameType frameType );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Frame"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SeriesRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SeriesRecord(Workbook *book);
    virtual ~SeriesRecord();

    SeriesRecord( const SeriesRecord& record );
    SeriesRecord& operator=( const SeriesRecord& record );

    enum DataTypeX {
        Numeric = 1,
        Textual = 3
    };

    static UString dataTypeXToString(DataTypeX dataTypeX);

    unsigned bubbleSizeDataType() const;
    void setBubbleSizeDataType( unsigned bubbleSizeDataType );

    unsigned countBubbleSizeValues() const;
    void setCountBubbleSizeValues( unsigned countBubbleSizeValues );

    unsigned countXValues() const;
    void setCountXValues( unsigned countXValues );

    unsigned countYValues() const;
    void setCountYValues( unsigned countYValues );

    DataTypeX dataTypeX() const;
    void setDataTypeX( DataTypeX dataTypeX );

    unsigned dataTypeY() const;
    void setDataTypeY( unsigned dataTypeY );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Series"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SeriesTextRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SeriesTextRecord(Workbook *book);
    virtual ~SeriesTextRecord();

    SeriesTextRecord( const SeriesTextRecord& record );
    SeriesTextRecord& operator=( const SeriesTextRecord& record );

    unsigned stringLength() const;
    void setStringLength( unsigned stringLength );

    UString text() const;
    void setText( UString text );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "SeriesText"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class GridSetReservedRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    GridSetReservedRecord(Workbook *book);
    virtual ~GridSetReservedRecord();

    GridSetReservedRecord( const GridSetReservedRecord& record );
    GridSetReservedRecord& operator=( const GridSetReservedRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "GridSetReserved"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DSFReservedRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DSFReservedRecord(Workbook *book);
    virtual ~DSFReservedRecord();

    DSFReservedRecord( const DSFReservedRecord& record );
    DSFReservedRecord& operator=( const DSFReservedRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "DSFReserved"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class Excel9FileRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    Excel9FileRecord(Workbook *book);
    virtual ~Excel9FileRecord();

    Excel9FileRecord( const Excel9FileRecord& record );
    Excel9FileRecord& operator=( const Excel9FileRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Excel9File"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class MmsReservedRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    MmsReservedRecord(Workbook *book);
    virtual ~MmsReservedRecord();

    MmsReservedRecord( const MmsReservedRecord& record );
    MmsReservedRecord& operator=( const MmsReservedRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "MmsReserved"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class Compat12Record : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    Compat12Record(Workbook *book);
    virtual ~Compat12Record();

    Compat12Record( const Compat12Record& record );
    Compat12Record& operator=( const Compat12Record& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Compat12"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class Window1Record : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    Window1Record(Workbook *book);
    virtual ~Window1Record();

    Window1Record( const Window1Record& record );
    Window1Record& operator=( const Window1Record& record );

    unsigned cTabSel() const;
    void setCTabSel( unsigned cTabSel );

    int dxWn() const;
    void setDxWn( int dxWn );

    int dyWn() const;
    void setDyWn( int dyWn );

    bool isFBotAdornment() const;
    void setFBotAdornment( bool fBotAdornment );

    bool isFDspHScroll() const;
    void setFDspHScroll( bool fDspHScroll );

    bool isFDspVScroll() const;
    void setFDspVScroll( bool fDspVScroll );

    bool isFHidden() const;
    void setFHidden( bool fHidden );

    bool isFIconic() const;
    void setFIconic( bool fIconic );

    bool isFNoAFDateGroup() const;
    void setFNoAFDateGroup( bool fNoAFDateGroup );

    bool isFVeryHidden() const;
    void setFVeryHidden( bool fVeryHidden );

    unsigned itabCur() const;
    void setItabCur( unsigned itabCur );

    unsigned itabFirst() const;
    void setItabFirst( unsigned itabFirst );

    unsigned wTabRatio() const;
    void setWTabRatio( unsigned wTabRatio );

    int xWn() const;
    void setXWn( int xWn );

    int yWn() const;
    void setYWn( int yWn );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Window1"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class Window2Record : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    Window2Record(Workbook *book);
    virtual ~Window2Record();

    Window2Record( const Window2Record& record );
    Window2Record& operator=( const Window2Record& record );

    unsigned colLeft() const;
    void setColLeft( unsigned colLeft );

    bool isFDefaultHdr() const;
    void setFDefaultHdr( bool fDefaultHdr );

    bool isFDspFmlaRt() const;
    void setFDspFmlaRt( bool fDspFmlaRt );

    bool isFDspGridRt() const;
    void setFDspGridRt( bool fDspGridRt );

    bool isFDspGuts() const;
    void setFDspGuts( bool fDspGuts );

    bool isFDspRwColRt() const;
    void setFDspRwColRt( bool fDspRwColRt );

    bool isFDspZerosRt() const;
    void setFDspZerosRt( bool fDspZerosRt );

    bool isFFrozenNoSplit() const;
    void setFFrozenNoSplit( bool fFrozenNoSplit );

    bool isFFrozenRt() const;
    void setFFrozenRt( bool fFrozenRt );

    bool isFPaged() const;
    void setFPaged( bool fPaged );

    bool isFRightToLeft() const;
    void setFRightToLeft( bool fRightToLeft );

    bool isFSLV() const;
    void setFSLV( bool fSLV );

    bool isFSelected() const;
    void setFSelected( bool fSelected );

    unsigned rwTop() const;
    void setRwTop( unsigned rwTop );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Window2"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ObjProtectedRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ObjProtectedRecord(Workbook *book);
    virtual ~ObjProtectedRecord();

    ObjProtectedRecord( const ObjProtectedRecord& record );
    ObjProtectedRecord& operator=( const ObjProtectedRecord& record );

    unsigned fLockObj() const;
    void setFLockObj( unsigned fLockObj );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ObjProtected"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ScenarioProtectRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ScenarioProtectRecord(Workbook *book);
    virtual ~ScenarioProtectRecord();

    ScenarioProtectRecord( const ScenarioProtectRecord& record );
    ScenarioProtectRecord& operator=( const ScenarioProtectRecord& record );

    unsigned fScenProtect() const;
    void setFScenProtect( unsigned fScenProtect );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ScenarioProtect"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class WinProtectRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    WinProtectRecord(Workbook *book);
    virtual ~WinProtectRecord();

    WinProtectRecord( const WinProtectRecord& record );
    WinProtectRecord& operator=( const WinProtectRecord& record );

    unsigned fLockWin() const;
    void setFLockWin( unsigned fLockWin );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "WinProtect"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class Prot4RevRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    Prot4RevRecord(Workbook *book);
    virtual ~Prot4RevRecord();

    Prot4RevRecord( const Prot4RevRecord& record );
    Prot4RevRecord& operator=( const Prot4RevRecord& record );

    unsigned fRevLock() const;
    void setFRevLock( unsigned fRevLock );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Prot4Rev"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class Prot4RevPassRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    Prot4RevPassRecord(Workbook *book);
    virtual ~Prot4RevPassRecord();

    Prot4RevPassRecord( const Prot4RevPassRecord& record );
    Prot4RevPassRecord& operator=( const Prot4RevPassRecord& record );

    unsigned protPwdRev() const;
    void setProtPwdRev( unsigned protPwdRev );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Prot4RevPass"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PasswordRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PasswordRecord(Workbook *book);
    virtual ~PasswordRecord();

    PasswordRecord( const PasswordRecord& record );
    PasswordRecord& operator=( const PasswordRecord& record );

    unsigned wPassword() const;
    void setWPassword( unsigned wPassword );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Password"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class FeatHdrRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    FeatHdrRecord(Workbook *book);
    virtual ~FeatHdrRecord();

    FeatHdrRecord( const FeatHdrRecord& record );
    FeatHdrRecord& operator=( const FeatHdrRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "FeatHdr"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class IndexRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    IndexRecord(Workbook *book);
    virtual ~IndexRecord();

    IndexRecord( const IndexRecord& record );
    IndexRecord& operator=( const IndexRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Index"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class GutsRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    GutsRecord(Workbook *book);
    virtual ~GutsRecord();

    GutsRecord( const GutsRecord& record );
    GutsRecord& operator=( const GutsRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Guts"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class WsBoolRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    WsBoolRecord(Workbook *book);
    virtual ~WsBoolRecord();

    WsBoolRecord( const WsBoolRecord& record );
    WsBoolRecord& operator=( const WsBoolRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "WsBool"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class HeaderFooterRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    HeaderFooterRecord(Workbook *book);
    virtual ~HeaderFooterRecord();

    HeaderFooterRecord( const HeaderFooterRecord& record );
    HeaderFooterRecord& operator=( const HeaderFooterRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "HeaderFooter"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PLVRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PLVRecord(Workbook *book);
    virtual ~PLVRecord();

    PLVRecord( const PLVRecord& record );
    PLVRecord& operator=( const PLVRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "PLV"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CalcSaveRecalcRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CalcSaveRecalcRecord(Workbook *book);
    virtual ~CalcSaveRecalcRecord();

    CalcSaveRecalcRecord( const CalcSaveRecalcRecord& record );
    CalcSaveRecalcRecord& operator=( const CalcSaveRecalcRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CalcSaveRecalc"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class InterfaceHdrRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    InterfaceHdrRecord(Workbook *book);
    virtual ~InterfaceHdrRecord();

    InterfaceHdrRecord( const InterfaceHdrRecord& record );
    InterfaceHdrRecord& operator=( const InterfaceHdrRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "InterfaceHdr"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class InterfaceEndRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    InterfaceEndRecord(Workbook *book);
    virtual ~InterfaceEndRecord();

    InterfaceEndRecord( const InterfaceEndRecord& record );
    InterfaceEndRecord& operator=( const InterfaceEndRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "InterfaceEnd"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class RRTabIdRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    RRTabIdRecord(Workbook *book);
    virtual ~RRTabIdRecord();

    RRTabIdRecord( const RRTabIdRecord& record );
    RRTabIdRecord& operator=( const RRTabIdRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "RRTabId"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BuiltInFnGroupCountRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BuiltInFnGroupCountRecord(Workbook *book);
    virtual ~BuiltInFnGroupCountRecord();

    BuiltInFnGroupCountRecord( const BuiltInFnGroupCountRecord& record );
    BuiltInFnGroupCountRecord& operator=( const BuiltInFnGroupCountRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "BuiltInFnGroupCount"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class HideObjRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    HideObjRecord(Workbook *book);
    virtual ~HideObjRecord();

    HideObjRecord( const HideObjRecord& record );
    HideObjRecord& operator=( const HideObjRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "HideObj"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class RefreshAllRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    RefreshAllRecord(Workbook *book);
    virtual ~RefreshAllRecord();

    RefreshAllRecord( const RefreshAllRecord& record );
    RefreshAllRecord& operator=( const RefreshAllRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "RefreshAll"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class RecalcIdRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    RecalcIdRecord(Workbook *book);
    virtual ~RecalcIdRecord();

    RecalcIdRecord( const RecalcIdRecord& record );
    RecalcIdRecord& operator=( const RecalcIdRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "RecalcId"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BookBoolRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BookBoolRecord(Workbook *book);
    virtual ~BookBoolRecord();

    BookBoolRecord( const BookBoolRecord& record );
    BookBoolRecord& operator=( const BookBoolRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "BookBool"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class StyleRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    StyleRecord(Workbook *book);
    virtual ~StyleRecord();

    StyleRecord( const StyleRecord& record );
    StyleRecord& operator=( const StyleRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Style"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class StyleExtRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    StyleExtRecord(Workbook *book);
    virtual ~StyleExtRecord();

    StyleExtRecord( const StyleExtRecord& record );
    StyleExtRecord& operator=( const StyleExtRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "StyleExt"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ExtSSTRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ExtSSTRecord(Workbook *book);
    virtual ~ExtSSTRecord();

    ExtSSTRecord( const ExtSSTRecord& record );
    ExtSSTRecord& operator=( const ExtSSTRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ExtSST"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class UsesELFsRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    UsesELFsRecord(Workbook *book);
    virtual ~UsesELFsRecord();

    UsesELFsRecord( const UsesELFsRecord& record );
    UsesELFsRecord& operator=( const UsesELFsRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "UsesELFs"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class DBCellRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    DBCellRecord(Workbook *book);
    virtual ~DBCellRecord();

    DBCellRecord( const DBCellRecord& record );
    DBCellRecord& operator=( const DBCellRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "DBCell"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PhoneticInfoRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PhoneticInfoRecord(Workbook *book);
    virtual ~PhoneticInfoRecord();

    PhoneticInfoRecord( const PhoneticInfoRecord& record );
    PhoneticInfoRecord& operator=( const PhoneticInfoRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "PhoneticInfo"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CalcCountRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CalcCountRecord(Workbook *book);
    virtual ~CalcCountRecord();

    CalcCountRecord( const CalcCountRecord& record );
    CalcCountRecord& operator=( const CalcCountRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CalcCount"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CalcPrecisionRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CalcPrecisionRecord(Workbook *book);
    virtual ~CalcPrecisionRecord();

    CalcPrecisionRecord( const CalcPrecisionRecord& record );
    CalcPrecisionRecord& operator=( const CalcPrecisionRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CalcPrecision"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CalcDeltaRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CalcDeltaRecord(Workbook *book);
    virtual ~CalcDeltaRecord();

    CalcDeltaRecord( const CalcDeltaRecord& record );
    CalcDeltaRecord& operator=( const CalcDeltaRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CalcDelta"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CalcIterRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CalcIterRecord(Workbook *book);
    virtual ~CalcIterRecord();

    CalcIterRecord( const CalcIterRecord& record );
    CalcIterRecord& operator=( const CalcIterRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CalcIter"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CalcRefModeRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CalcRefModeRecord(Workbook *book);
    virtual ~CalcRefModeRecord();

    CalcRefModeRecord( const CalcRefModeRecord& record );
    CalcRefModeRecord& operator=( const CalcRefModeRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CalcRefMode"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CodePageRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CodePageRecord(Workbook *book);
    virtual ~CodePageRecord();

    CodePageRecord( const CodePageRecord& record );
    CodePageRecord& operator=( const CodePageRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CodePage"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CountryRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CountryRecord(Workbook *book);
    virtual ~CountryRecord();

    CountryRecord( const CountryRecord& record );
    CountryRecord& operator=( const CountryRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Country"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class SelectionRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    SelectionRecord(Workbook *book);
    virtual ~SelectionRecord();

    SelectionRecord( const SelectionRecord& record );
    SelectionRecord& operator=( const SelectionRecord& record );

    unsigned colAct() const;
    void setColAct( unsigned colAct );

    unsigned cref() const;
    void setCref( unsigned cref );

    unsigned irefAct() const;
    void setIrefAct( unsigned irefAct );

    unsigned pnn() const;
    void setPnn( unsigned pnn );

    unsigned rwAct() const;
    void setRwAct( unsigned rwAct );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Selection"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PrinterSettingsRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PrinterSettingsRecord(Workbook *book);
    virtual ~PrinterSettingsRecord();

    PrinterSettingsRecord( const PrinterSettingsRecord& record );
    PrinterSettingsRecord& operator=( const PrinterSettingsRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "PrinterSettings"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PrintRowColRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PrintRowColRecord(Workbook *book);
    virtual ~PrintRowColRecord();

    PrintRowColRecord( const PrintRowColRecord& record );
    PrintRowColRecord& operator=( const PrintRowColRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "PrintRowCol"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class PrintGridRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    PrintGridRecord(Workbook *book);
    virtual ~PrintGridRecord();

    PrintGridRecord( const PrintGridRecord& record );
    PrintGridRecord& operator=( const PrintGridRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "PrintGrid"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class LastWriteAccessRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    LastWriteAccessRecord(Workbook *book);
    virtual ~LastWriteAccessRecord();

    LastWriteAccessRecord( const LastWriteAccessRecord& record );
    LastWriteAccessRecord& operator=( const LastWriteAccessRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "LastWriteAccess"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class XFExtRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    XFExtRecord(Workbook *book);
    virtual ~XFExtRecord();

    XFExtRecord( const XFExtRecord& record );
    XFExtRecord& operator=( const XFExtRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "XFExt"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class XFCRCRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    XFCRCRecord(Workbook *book);
    virtual ~XFCRCRecord();

    XFCRCRecord( const XFCRCRecord& record );
    XFCRCRecord& operator=( const XFCRCRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "XFCRC"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class TableStylesRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    TableStylesRecord(Workbook *book);
    virtual ~TableStylesRecord();

    TableStylesRecord( const TableStylesRecord& record );
    TableStylesRecord& operator=( const TableStylesRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "TableStyles"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class MTRSettingsRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    MTRSettingsRecord(Workbook *book);
    virtual ~MTRSettingsRecord();

    MTRSettingsRecord( const MTRSettingsRecord& record );
    MTRSettingsRecord& operator=( const MTRSettingsRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "MTRSettings"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ForceFullCalculationRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ForceFullCalculationRecord(Workbook *book);
    virtual ~ForceFullCalculationRecord();

    ForceFullCalculationRecord( const ForceFullCalculationRecord& record );
    ForceFullCalculationRecord& operator=( const ForceFullCalculationRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "ForceFullCalculation"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class BookExtRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    BookExtRecord(Workbook *book);
    virtual ~BookExtRecord();

    BookExtRecord( const BookExtRecord& record );
    BookExtRecord& operator=( const BookExtRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "BookExt"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class ThemeRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    ThemeRecord(Workbook *book);
    virtual ~ThemeRecord();

    ThemeRecord( const ThemeRecord& record );
    ThemeRecord& operator=( const ThemeRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "Theme"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class CompressPicturesRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    CompressPicturesRecord(Workbook *book);
    virtual ~CompressPicturesRecord();

    CompressPicturesRecord( const CompressPicturesRecord& record );
    CompressPicturesRecord& operator=( const CompressPicturesRecord& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "CompressPictures"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AutoFilterRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AutoFilterRecord(Workbook *book);
    virtual ~AutoFilterRecord();

    AutoFilterRecord( const AutoFilterRecord& record );
    AutoFilterRecord& operator=( const AutoFilterRecord& record );

    enum Join {
        JoinAnd = 0,
        JoinOr = 1
    };

    static UString joinToString(Join join);

    enum TopDirection {
        TopNBottom = 0,
        TopNTop = 1
    };

    static UString topDirectionToString(TopDirection topDirection);

    unsigned entry() const;
    void setEntry( unsigned entry );

    Join join() const;
    void setJoin( Join join );

    bool isSimple1() const;
    void setSimple1( bool simple1 );

    bool isSimple2() const;
    void setSimple2( bool simple2 );

    TopDirection topDirection() const;
    void setTopDirection( TopDirection topDirection );

    bool isTopN() const;
    void setTopN( bool topN );

    unsigned topNCount() const;
    void setTopNCount( unsigned topNCount );

    bool isTopPercentage() const;
    void setTopPercentage( bool topPercentage );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "AutoFilter"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AutoFilter12Record : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AutoFilter12Record(Workbook *book);
    virtual ~AutoFilter12Record();

    AutoFilter12Record( const AutoFilter12Record& record );
    AutoFilter12Record& operator=( const AutoFilter12Record& record );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "AutoFilter12"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

class AutoFilterInfoRecord : public Record
{
public:
    static const unsigned id;

    virtual unsigned rtti() const { return this->id; }

    AutoFilterInfoRecord(Workbook *book);
    virtual ~AutoFilterInfoRecord();

    AutoFilterInfoRecord( const AutoFilterInfoRecord& record );
    AutoFilterInfoRecord& operator=( const AutoFilterInfoRecord& record );

    unsigned entries() const;
    void setEntries( unsigned entries );

    virtual void setData( unsigned size, const unsigned char* data, const unsigned* continuePositions );

    virtual const char* name() const { return "AutoFilterInfo"; }

    virtual void dump( std::ostream& out ) const;

private:
    class Private;
    Private * const d;
};

} // namespace Swinder

#endif // SWINDER_RECORDS_H
